package ch.unige.solidify.process;

import java.io.Serializable;

import javax.xml.bind.JAXBElement;

import ch.unige.solidify.model.xml.xhtml.v1.XhtmlAType;
import ch.unige.solidify.model.xml.xhtml.v1.XhtmlHtmlType;
import ch.unige.solidify.model.xml.xhtml.v1.XhtmlLiType;
import ch.unige.solidify.model.xml.xhtml.v1.XhtmlUlType;

public class HrefUpdateProcess extends BaseProcess {
  private String fileName;

  public HrefUpdateProcess(String fileName) {
    this.fileName = fileName;
  }

  @Override
  public JAXBElement<XhtmlUlType> process(JAXBElement<XhtmlHtmlType> html, JAXBElement<XhtmlUlType> toc) {
    this.updateLink(toc.getValue());
    return toc;
  }

  private void updateLink(XhtmlUlType toc) {
    for (XhtmlLiType li : toc.getLi()) {
      for (Serializable item : li.getContent()) {
        if (item instanceof JAXBElement<?>) {
          Object obj = ((JAXBElement<?>) item).getValue();
          if (obj instanceof XhtmlUlType) {
            updateLink((XhtmlUlType) obj);
          } else if (obj instanceof XhtmlAType) {
            XhtmlAType link = (XhtmlAType) obj;
            link.setHref(this.fileName + link.getHref());
            link.setTarget("_blank");
          }
        }
      }
    }
  }
}
