package ch.unige.solidify.test;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import javax.xml.bind.JAXBException;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.junit.jupiter.MockitoExtension;

import ch.unige.solidify.AsciidoctorTocExtracter;
import ch.unige.solidify.process.TocExtractionException;

import junit.framework.TestCase;

@ExtendWith(MockitoExtension.class)
public class AsciidoctorTocExtracterTest extends TestCase {
  private static String SRC_TEST_RESOURCES = "src/test/resources/";
  private static String DLCM_GUIDE = SRC_TEST_RESOURCES + "DLCM-IntegrationGuide.html";
  private static String DLCM_GUIDE_TOC = SRC_TEST_RESOURCES + "DLCM-IntegrationGuide-toc.html";
  private final AsciidoctorTocExtracter tocExtracter = new AsciidoctorTocExtracter();

  @Test
  public void testRun() throws Exception {
    try {
      tocExtracter.load(DLCM_GUIDE);
      tocExtracter.run(null);
      tocExtracter.generate();
      Path toc = Paths.get(DLCM_GUIDE_TOC);
      assertTrue(toc.toFile().exists());
      Files.delete(toc);
    } catch (JAXBException | IOException | TocExtractionException e) {
      throw e;
    }

  }

}
