package ch.unige.solidify.test;

import java.io.FileReader;
import java.nio.file.Path;
import java.nio.file.Paths;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.junit.jupiter.MockitoExtension;

import ch.unige.solidify.model.xml.xhtml.v1.XhtmlHtmlType;

@ExtendWith(MockitoExtension.class)
public class HTMLTest {
  private static String SRC_TEST_RESOURCES = "src/test/resources/";
  private static String DLCM_METADATA_HTML_SCHEMA_ORG = SRC_TEST_RESOURCES + "jaxb/dlcm-html-schema.org.xml";
  private static String DLCM_GUIDE = SRC_TEST_RESOURCES + "DLCM-IntegrationGuide.html";

  @Test
  public void unloadXHTMLTest() throws Exception {
    Path in = Paths.get(DLCM_METADATA_HTML_SCHEMA_ORG);
    JAXBContext jaxbContext = JAXBContext.newInstance(XhtmlHtmlType.class);
    try (FileReader fileReader = new FileReader(in.toFile())) {
      JAXBElement<XhtmlHtmlType> root = (JAXBElement<XhtmlHtmlType>) jaxbContext.createUnmarshaller().unmarshal(fileReader);
      jaxbContext.createMarshaller().marshal(root, System.out);
    } catch (Exception e) {
      e.printStackTrace();
      throw e;
    }
  }

  @Test
  public void unloadAsciidoctorHTMLTest() throws Exception {
    Path in = Paths.get(DLCM_GUIDE);
    JAXBContext jaxbContext = JAXBContext.newInstance(XhtmlHtmlType.class);
    try (FileReader fileReader = new FileReader(in.toFile())) {
      JAXBElement<XhtmlHtmlType> root = (JAXBElement<XhtmlHtmlType>) jaxbContext.createUnmarshaller().unmarshal(fileReader);
      jaxbContext.createMarshaller().marshal(root, System.out);
    } catch (Exception e) {
      e.printStackTrace();
      throw e;
    }
  }

  private JAXBContext getJaxbContext() throws JAXBException {
    return JAXBContext.newInstance(XhtmlHtmlType.class);
  }

}