package ch.unige.solidify.model;

import ch.unige.solidify.process.BaseProcess;

public class PageObject extends AttributeObject {
  private PageProperties properties = new PageProperties();

  public PageObject() {
    this.setType(BaseProcess.OBJECT);
    this.setDescription("Gives the total pages and the total available items of one resource");
    this.properties.setCurrentPage(new AttributeObject(BaseProcess.NUMBER, "The current page number"));
    this.properties.setSizePage(new AttributeObject(BaseProcess.NUMBER, "The number of item per page"));
    this.properties.setTotalItems(new AttributeObject(BaseProcess.NUMBER, "The total number of items"));
    this.properties.setTotalPages(new AttributeObject(BaseProcess.NUMBER, "The total number of page"));
  }

  public class PageProperties {
    private AttributeObject totalPages;
    private AttributeObject totalItems;
    private AttributeObject currentPage;
    private AttributeObject sizePage;

    public void setTotalPages(AttributeObject totalPages) {
      this.totalPages = totalPages;
    }

    public void setTotalItems(AttributeObject totalItems) {
      this.totalItems = totalItems;
    }

    public void setCurrentPage(AttributeObject currentPage) {
      this.currentPage = currentPage;
    }

    public void setSizePage(AttributeObject sizePage) {
      this.sizePage = sizePage;
    }

    public AttributeObject getTotalPages() {
      return totalPages;
    }

    public AttributeObject getTotalItems() {
      return totalItems;
    }

    public AttributeObject getCurrentPage() {
      return currentPage;
    }

    public AttributeObject getSizePage() {
      return sizePage;
    }
  }

  public PageProperties getProperties() {
    return properties;
  }

}
