package ch.unige.solidify.process;

import org.json.JSONArray;
import org.json.JSONObject;

/**
 * Update tags with module name
 */
public class OAuth2SecurityProcess extends BaseProcess {
  private String securityName;
  private static final String SOLIDIFY_OAUTH2 = "{\"type\" : \"oauth2\", \"flows\" : { \"implicit\" : { \"authorizationUrl\" : \"https://localhost\", \"scopes\" : {} } } }";

  public OAuth2SecurityProcess(String securityName) {
    this.securityName = securityName;
  }

  public void process(JSONObject json) {
    // Add Security
    json.put("security", this.getSecurity());
    // Add Security Scheme
    this.getComponentsNode(json).put("securitySchemes", this.getSecuritySchemes());
  }

  private JSONObject getSecuritySchemes() {
    JSONObject securitySchemes = new JSONObject();
    JSONObject oauth2 = new JSONObject(SOLIDIFY_OAUTH2);
    securitySchemes.put(this.securityName, oauth2);
    return securitySchemes;
  }

  private JSONArray getSecurity() {
    JSONArray security = new JSONArray();
    JSONObject auth = new JSONObject();
    auth.put(this.securityName, new JSONArray());
    security.put(auth);
    return security;
  }

}
