package ch.unige.solidify.process;

import java.util.HashMap;
import java.util.Map;

import org.json.JSONObject;

/**
 * Define old & new name relationship with webservice
 */
public class PathNormalizationProcess extends BaseProcess {

  private String contextPath;

  public PathNormalizationProcess(String contextPath) {
    this.contextPath = contextPath;
  }

  public void process(JSONObject json) {
    JSONObject pathsJson = this.getPathsNode(json);
    Map<String, Object> newList = new HashMap<>();

    // Rename & save path object
    for (String path : pathsJson.keySet()) {
      JSONObject pathObj = pathsJson.getJSONObject(path);

      // Remove prefix of context path
      String newPath;
      if (path.equals(this.contextPath)) {
        newPath = "/";
      } else {
        newPath = path.substring(this.contextPath.length());
      }
      long count = this.countCharacter(path, '/');
      if (count == 4) {
        newPath = path.substring(this.contextPath.length(), path.lastIndexOf('/'));
      }
      newList.put(newPath, pathObj);
    }

    // Update paths object
    this.migrateNodes(json, PATHS_KEY, newList);
  }

}
