package ch.unige.solidify.process;

import java.util.Iterator;

import org.json.JSONObject;

/**
 * Remove examples node in responses and requestBody
 */
public class PathRemoveExampleProcess extends BaseProcess {
  public PathRemoveExampleProcess() {
  }

  public void process(JSONObject json) {
    for (Iterator<String> i = this.getPathsNode(json).keys(); i.hasNext();) {
      String pathName = i.next();
      JSONObject path = this.getPathsNode(json).getJSONObject(pathName);
      iterateOverVerb(path);
    }
  }

  private void iterateOverVerb(JSONObject path) {
    for (Iterator<String> i = path.keys(); i.hasNext();) {
      String verbName = i.next();
      JSONObject verb = path.getJSONObject(verbName);
      removeExamples(verbName, verb);
    }
  }

  private void removeExamples(String verbName, JSONObject verb) {
    removeExamplesInResponses(verb);
    if (verbName.equals(POST_PATH)) {
      removeExamplesInRequestBody(verb);
    }
  }

  private void removeExamplesInResponses(JSONObject verb) {
    JSONObject responsesNode = verb.getJSONObject(RESPONSES_KEY);
    JSONObject codeResultNode = getFirstChild(responsesNode);
    JSONObject contentNode = codeResultNode.getJSONObject(CONTENT_KEY);
    JSONObject applicationHalJsonNode = getFirstChild(contentNode);
    applicationHalJsonNode.remove(EXAMPLES_KEY);
  }

  private void removeExamplesInRequestBody(JSONObject verb) {
    JSONObject requestBodyNode = verb.getJSONObject(REQUEST_BODY_KEY);
    JSONObject contentNode = getFirstChild(requestBodyNode);
    JSONObject applicationHalJsonNode = getFirstChild(contentNode);
    applicationHalJsonNode.remove(EXAMPLES_KEY);
  }
}
