package ch.unige.solidify.process;

import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONObject;

/**
 * Update tags with module name
 */
public class PathUpdateTagsProcess extends BaseProcess {
  public PathUpdateTagsProcess() {
  }

  public void process(JSONObject json) {
    for (Iterator<String> i = this.getPathsNode(json).keys(); i.hasNext();) {
      String pathName = i.next();
      if (pathName.equals("/")) {
        continue;
      }
      JSONObject path = this.getPathsNode(json).getJSONObject(pathName);
      String[] paths = pathName.split("\\/");
      for (Iterator<String> j = path.keys(); j.hasNext();) {
        String wsName = j.next();
        JSONArray tags = path.getJSONObject(wsName).getJSONArray("tags");
        // Add module
        tags.put(paths[1]);
        // Add resource
        if (paths.length > 2) {
          tags.put(paths[2]);
        }
      }
    }
  }

}
