package ch.unige.solidify.process;

import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONObject;

/**
 * Update tags with module name
 */
public class RemoveNullFieldsProcess extends BaseProcess {
  public RemoveNullFieldsProcess() {
  }

  public void process(JSONObject json) {
    for (Iterator<String> i = json.keys(); i.hasNext();) {
      String field = i.next();
      removeNullFields(json.get(field));
    }
  }

  private void removeNullFields(Object o) {
    if (o instanceof JSONArray) {
      JSONArray array = (JSONArray) o;
      for (int i = 0; i < array.length(); ++i)
        removeNullFields(array.get(i));
    } else if (o instanceof JSONObject) {
      JSONObject json = (JSONObject) o;
      JSONArray names = json.names();
      if (names == null)
        return;
      for (int i = 0; i < names.length(); ++i) {
        String key = names.getString(i);
        if (json.isNull(key)) {
          json.remove(key);
        } else {
          removeNullFields(json.get(key));
        }
      }
    }
  }

}
